Home | History | Annotate | Download | only in packet-flood
      1 #!/bin/sh
      2 
      3 ################################################################################
      4 ##                                                                            ##
      5 ## Copyright (c) International Business Machines  Corp., 2006                 ##
      6 ##                                                                            ##
      7 ## This program is free software;  you can redistribute it and#or modify      ##
      8 ## it under the terms of the GNU General Public License as published by       ##
      9 ## the Free Software Foundation; either version 2 of the License, or          ##
     10 ## (at your option) any later version.                                        ##
     11 ##                                                                            ##
     12 ## This program is distributed in the hope that it will be useful, but        ##
     13 ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
     14 ## or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   ##
     15 ## for more details.                                                          ##
     16 ##                                                                            ##
     17 ## You should have received a copy of the GNU General Public License          ##
     18 ## along with this program;  if not, write to the Free Software               ##
     19 ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA    ##
     20 ##                                                                            ##
     21 ##                                                                            ##
     22 ################################################################################
     23 #
     24 # File:
     25 #   mcast6-pktfld01
     26 #
     27 # Description:
     28 #   Verify that the kernel is not crashed when joining a IPv6 multicast group
     29 #   a single socket, then receiving a large number of UDP packets at the socket
     30 #
     31 # Setup:
     32 #   See ltp-yyyymmdd/testcases/network/stress/README
     33 #
     34 # Author:
     35 #   Mitsuru Chinen <mitch (at] jp.ibm.com>
     36 #
     37 # History:
     38 #	May 6 2006 - Created (Mitsuru Chinen)
     39 #
     40 #-----------------------------------------------------------------------
     41 # Uncomment line below for debug output.
     42 #trace_logic=${trace_logic:-"set -x"}
     43 $trace_logic
     44 
     45 # The test case ID, the test case count and the total number of test case
     46 TCID=mcast6-pktfld01
     47 TST_TOTAL=1
     48 TST_COUNT=1
     49 export TCID
     50 export TST_COUNT
     51 export TST_TOTAL
     52 
     53 # Make sure the value of LTPROOT
     54 LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
     55 export LTPROOT
     56 
     57 # Check the environmanet variable
     58 . check_envval || exit $TST_TOTAL
     59 
     60 # Dulation of the test [sec]
     61 NS_DURATION=${NS_DURATION:-3600}      # 1 hour
     62 
     63 # The number of the test link where tests run
     64 LINK_NUM=${LINK_NUM:-0}
     65 
     66 # Network portion of the IPv6 address
     67 NETWORK_PART="fec0:1:1:1"
     68 
     69 # Host portion of the IPv6 address
     70 LHOST_HOST_PART=":2"     # local host
     71 RHOST_HOST_PART=":1"     # remote host
     72 
     73 # Multicast Address
     74 MCAST_ADDR=ff0e::1111:1
     75 
     76 
     77 #-----------------------------------------------------------------------
     78 #
     79 # Function: do_cleanup
     80 #
     81 # Description:
     82 #   Recover the system configuration
     83 #
     84 #-----------------------------------------------------------------------
     85 do_cleanup()
     86 {
     87     # Make sure to kill the multicast receiver and sender
     88     killall -SIGHUP ns-mcast_receiver >/dev/null 2>&1
     89     $LTP_RSH $RHOST killall -SIGHUP ns-udpsender >/dev/null 2>&1
     90 
     91     # Clean up each interface
     92     initialize_if lhost ${LINK_NUM}
     93     initialize_if rhost ${LINK_NUM}
     94 }
     95 
     96 
     97 #-----------------------------------------------------------------------
     98 #
     99 # Function: do_setup
    100 #
    101 # Description:
    102 #   Configure the ssystem for the test
    103 #
    104 #-----------------------------------------------------------------------
    105 do_setup()
    106 {
    107     # Initialize the system configuration
    108     do_cleanup
    109 
    110     # Call do_cleanup function before exit
    111     trap do_cleanup 0
    112 
    113     # Unset the maximum number of processes
    114     ulimit -u unlimited
    115 
    116     # name of interface of the local/remote host
    117     lhost_ifname=`get_ifname lhost $LINK_NUM`
    118     if [ $? -ne 0 ]; then
    119 	tst_resm TBROK "Failed to get the interface name at the local host"
    120 	exit $TST_TOTAL
    121     fi
    122 
    123     rhost_ifname=`get_ifname rhost $LINK_NUM`
    124     if [ $? -ne 0 ]; then
    125 	tst_resm TBROK "Failed to get the interface name at the remote host"
    126 	exit $TST_TOTAL
    127     fi
    128 
    129     # Set IPv6 addresses to the interfaces
    130     add_ipv6addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
    131     if [ $? -ne 0 ]; then
    132 	tst_resm TBROK "Failed to add any IP address at the local host"
    133 	exit 1
    134     fi
    135 
    136     add_ipv6addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
    137     if [ $? -ne 0 ]; then
    138 	tst_resm TBROK "Failed to add any IP address at the remote host"
    139 	exit 1
    140     fi
    141 
    142     # IPv6 address of the local/remote host
    143     lhost_addr="${NETWORK_PART}:${LHOST_HOST_PART}"
    144     rhost_addr="${NETWORK_PART}:${RHOST_HOST_PART}"
    145 
    146     # Make sure the connectvity
    147     check_icmpv6_connectivity $lhost_ifname $rhost_addr
    148     if [ $? -ne 0 ]; then
    149 	tst_resm TBROK "There is no IPv6 connectivity."
    150 	exit 1
    151     fi
    152 
    153     # Make sure the sysctl values
    154     sysctl -w net.ipv6.conf.all.force_mld_version=0 >/dev/null
    155     if [ $? -ne 0 ]; then
    156 	tst_resm TBROK "Failed to set the sysctl value regarding multicast"
    157 	exit $TST_TOTAL
    158     fi
    159 
    160     sysctl -w net.ipv6.conf.${lhost_ifname}.force_mld_version=0 >/dev/null
    161     sysctl -w net.ipv6.mld_max_msf=10 >/dev/null
    162 }
    163 
    164 
    165 #-----------------------------------------------------------------------
    166 #
    167 # Main
    168 #
    169 #
    170 
    171 # Test description
    172 tst_resm TINFO "Verify that the kernel is not crashed when joining a IPv6 multicast group a single socket, then receiving a large number of UDP packets at the socket in $NS_DURATION [sec]"
    173 
    174 do_setup
    175 
    176 # Find the available consecutive ports
    177 mcast_port=`find_portbundle udp 1025 1`
    178 if [ $? -ne 0 ]; then
    179     tst_resm TBROK "No port is available."
    180     exit 1
    181 fi
    182 
    183 # Run a receiver
    184 ns-mcast_receiver -f 6 -I $lhost_ifname -m $MCAST_ADDR -p $mcast_port -b
    185 if [ $? -ne 0 ]; then
    186     tst_resm TBROK "Failed to start multicast receiver"
    187     exit 1
    188 fi
    189 
    190 # Run a sender
    191 ret=`$LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-udpsender -D $MCAST_ADDR -f 6 -p $mcast_port -s 32767 -m -I $rhost_ifname -t $NS_DURATION' ; echo $?'`
    192 if [ $ret -ne 0 ]; then
    193     tst_resm TBROK "Failed to start multicast sender"
    194     exit 1
    195 fi
    196 
    197 #-----------------------------------------------------------------------
    198 #
    199 # Clean up
    200 #
    201 
    202 tst_resm TPASS "Test is finished successfully."
    203 exit 0
    204